Subject: Question re. stateless DHCPv6 and 'M' & 'O' flags

From: "Mudric, Dusan (Dusan)" <[email-masked]>
Date: Tue, 12 May 2015 18:53:56 +0000

Hi Everyone,

I would appreciate your help answering the questions regarding the stateless DHCPv6 and ‘M’ & ‘O’ flags:

Background:
===========
Following RFC 2462, “O” flag in Router Advertisements is used to start stateless DHCPv6 client. When using ‘O’ flag, the end point shall support:

·         RFC 3736<ftp://ftp.rfc-editor.org/in-notes/rfc3736.txt> , that defines stateless DHCPv6 client

·         RFC 4242, that defines when the end point should refresh the configuration information.

Questions:
=========
If RFC 4862 removed ‘M’ & ‘O’ flags and obsoleted RFC 2462 (that defines ‘M’ & ‘O’ flags), why are the flags not deprecated? What is the value of referring to the obsoleted standard, in order to support flags in the solution that is not mature?

rfc4862#appendix-C
   o  Removed the text regarding the M and O flags, considering the
      maturity of implementations and operational experiences.
      ManagedFlag and OtherConfigFlag were removed accordingly.  (Note
      that this change does not mean the use of these flags is
      deprecated.)

In the thread “Re: Question re. RECONFIG in DHCPv6”, Bernie stated:
“The RFC 3736 document is really not something I would recommend following - see full RFC 3315 and implement those features you need (such as only Information-Request and Reply). 3736 was written to demonstrate that stateless dhcpv6 was rather simple to implement.”

Based on the fact that ‘M’ & ‘O’ flags are removed from the RFC 4862 and the statement above, can we say the stateless DHCPv6 is not mandatory and, consequently, ‘O’ flag is not required?

If stateless DHCPv6 is not used, stateful DHCPv6 is required. Then, ‘M’ flag is not needed.

Regards,
Dusan Mudric.

---

From: "STARK, BARBARA H" <[email-masked]>
Date: Tue, 12 May 2015 19:37:54 +0000

> If RFC 4862 removed ‘M’ & ‘O’ flags and obsoleted RFC 2462 (that defines ‘M’ & ‘O’ flags), why are the flags not deprecated? What is the value of referring to the obsoleted standard, in order to su…

<bhs> M and O flags were *not* defined in RFC 2462. They were originally defined in RFC 2461 (neighbor discovery), which was obsoleted by RFC 4861. Their definitions remain alive and well in RFC 4861. I would not suggest referring to any obsoleted standards for M and O flag implementation. I would recommend referring to RFC 4861.</bhs>

> Based on the fact that ‘M’ & ‘O’ flags are removed from the RFC 4862 and the statement above, can we say the stateless DHCPv6 is not mandatory and, consequently, ‘O’ flag is not required?

<bhs> Any host implementing IPv6 per RFC 6434 (node requirements) may or may not implement DHCPv6 client, since that identifies DHCPv6 client support as "SHOULD".  I, personally, have no expectations that a random IPv6-capable host device supports DHCPv6 client or has it enabled (if DHCPv6 client is supported). Less random devices, like CE routers, have additional RFCs that place expectations on them. RFC 7084 requires CE routers to implement DHCPv6 client on the WAN interface and to respect M and O flags (per rules provided in that RFC).</bhs>

> If stateless DHCPv6 is not used, stateful DHCPv6 is required. Then, ‘M’ flag is not needed.

<bhs> I don't follow the logic of this statement. Neither stateless nor stateful DHCPv6 client is required of RFC-6434-compliant nodes. RFC 7084 requires both of CE routers (and has rules regarding M/O behaviors), but makes CE router support for DHCPv6 server optional.</bhs>

---

From: Brian E Carpenter <[email-masked]>
Date: Wed, 13 May 2015 08:05:02 +1200

Hi Dusan,

The M/O flags are not obsolete. They are defined in RFC 4861.

You might want to read https://tools.ietf.org/html/draft-ietf-v6ops-dhcpv6-slaac-problem
(noting that it is still a draft, discussed in the v6ops WG) and you might move this
discussion to the v6ops list, too.

Regards
   Brian Carpenter

On 13/05/2015 06:53, Mudric, Dusan (Dusan) wrote:
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------
>

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Tue, 12 May 2015 22:16:41 +0000

Note that my statement in no way was to mean that stateless DHCPv6 is useless. Just that you should see RFC 3315 and implement those pieces needed for stateless if that was what you wanted rather than to follow RFC 3736 (it is 3736 that is not of much use).

-          Bernie

From: Mudric, Dusan (Dusan) [mailto:[email-masked]]
Sent: Tuesday, May 12, 2015 2:54 PM
To: Lorenzo Colitti; STARK, BARBARA H
Cc: Bernie Volz (volz); Lin, Ping (Ping); [email-masked]; Steven B.
Subject: Question re. stateless DHCPv6 and 'M' & 'O' flags

Hi Everyone,

Background:
===========

Questions:
=========

rfc4862#appendix-C

Regards,
Dusan Mudric.